!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! ping_pong_2.f90 --- TP2 : Communications point à point : ping-pong
!! 
!! Auteur          : Denis GIROU (CNRS/IDRIS - France) <Denis.Girou@idris.fr>
!! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program ping_pong_2
  USE MPI
  implicit none

  integer, dimension(MPI_STATUS_SIZE)  :: statut
  integer, parameter                   :: nb_valeurs=1000,etiquette=99
  integer                              :: rang,code
  ! Kind pour double precision
  integer, parameter                   :: dp = selected_real_kind(15,307)
  real(kind=dp)                        :: temps_debut,temps_fin
  real(kind=dp), dimension(nb_valeurs) :: valeurs
  integer                              :: typedp

  call MPI_INIT(code)

  call MPI_COMM_RANK(MPI_COMM_WORLD,rang,code)
  call MPI_TYPE_CREATE_F90_REAL(15,307,typedp,code)

  if (rang == 0) then
    call random_number(valeurs)
    temps_debut=MPI_WTIME()
    call MPI_SEND(valeurs,nb_valeurs,typedp,1,etiquette, &
                  MPI_COMM_WORLD,code)
    call MPI_RECV(valeurs,nb_valeurs,typedp,1,etiquette, &
                  MPI_COMM_WORLD,statut,code)
    temps_fin=MPI_WTIME()
    print ('("Moi, processus 0, j''ai envoye et recu ",i5, &
        & " valeurs (derniere = ",f4.2,") du processus 1", &
        & " en ",f8.6," secondes.")'), &
          nb_valeurs,valeurs(nb_valeurs),temps_fin-temps_debut
  elseif (rang == 1) then
    call MPI_RECV(valeurs,nb_valeurs,typedp,0,etiquette, &
                  MPI_COMM_WORLD,statut,code)
    call MPI_SEND(valeurs,nb_valeurs,typedp,0,etiquette, &
                  MPI_COMM_WORLD,code)
  end if

  call MPI_FINALIZE(code)

end program ping_pong_2
